/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Value Descriptor</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getBaseType <em>Base Type</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getTemplateTypes <em>Template Types</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getFullType <em>Full Type</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getStringRepresentation <em>String Representation</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getValueRepresentation <em>Value Representation</em>}</li>
 *   <li>{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getPointerRepresentation <em>Pointer Representation</em>}</li>
 * </ul>
 *
 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#getValueDescriptor()
 * @model abstract="true"
 * @generated
 */
public interface ValueDescriptor extends EObject {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * Returns the value of the '<em><b>Base Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Base Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Base Type</em>' attribute.
	 * @see #setBaseType(String)
	 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#getValueDescriptor_BaseType()
	 * @model required="true"
	 * @generated
	 */
	String getBaseType();

	/**
	 * Sets the value of the '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getBaseType <em>Base Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Base Type</em>' attribute.
	 * @see #getBaseType()
	 * @generated
	 */
	void setBaseType(String value);

	/**
	 * Returns the value of the '<em><b>Template Types</b></em>' attribute list.
	 * The list contents are of type {@link java.lang.String}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Template Types</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Template Types</em>' attribute list.
	 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#getValueDescriptor_TemplateTypes()
	 * @model
	 * @generated
	 */
	EList<String> getTemplateTypes();

	/**
	 * Returns the value of the '<em><b>Full Type</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Full Type</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Full Type</em>' attribute.
	 * @see #setFullType(String)
	 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#getValueDescriptor_FullType()
	 * @model required="true"
	 * @generated
	 */
	String getFullType();

	/**
	 * Sets the value of the '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getFullType <em>Full Type</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Full Type</em>' attribute.
	 * @see #getFullType()
	 * @generated
	 */
	void setFullType(String value);

	/**
	 * Returns the value of the '<em><b>String Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>String Representation</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>String Representation</em>' attribute.
	 * @see #setStringRepresentation(String)
	 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#getValueDescriptor_StringRepresentation()
	 * @model required="true"
	 * @generated
	 */
	String getStringRepresentation();

	/**
	 * Sets the value of the '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getStringRepresentation <em>String Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>String Representation</em>' attribute.
	 * @see #getStringRepresentation()
	 * @generated
	 */
	void setStringRepresentation(String value);

	/**
	 * Returns the value of the '<em><b>Value Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Value Representation</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Value Representation</em>' attribute.
	 * @see #setValueRepresentation(String)
	 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#getValueDescriptor_ValueRepresentation()
	 * @model required="true"
	 * @generated
	 */
	String getValueRepresentation();

	/**
	 * Sets the value of the '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getValueRepresentation <em>Value Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Value Representation</em>' attribute.
	 * @see #getValueRepresentation()
	 * @generated
	 */
	void setValueRepresentation(String value);

	/**
	 * Returns the value of the '<em><b>Pointer Representation</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Pointer Representation</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Pointer Representation</em>' attribute.
	 * @see #setPointerRepresentation(String)
	 * @see com.incquerylabs.emdw.valuedescriptor.ValuedescriptorPackage#getValueDescriptor_PointerRepresentation()
	 * @model required="true"
	 * @generated
	 */
	String getPointerRepresentation();

	/**
	 * Sets the value of the '{@link com.incquerylabs.emdw.valuedescriptor.ValueDescriptor#getPointerRepresentation <em>Pointer Representation</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Pointer Representation</em>' attribute.
	 * @see #getPointerRepresentation()
	 * @generated
	 */
	void setPointerRepresentation(String value);

} // ValueDescriptor
