/**
 * Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation
 */
package com.incquerylabs.emdw.valuedescriptor.impl;

import com.incquerylabs.emdw.valuedescriptor.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ValuedescriptorFactoryImpl extends EFactoryImpl implements ValuedescriptorFactory {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "Copyright (c) 2015-2016 IncQuery Labs Ltd. and Ericsson AB\r\nAll rights reserved. This program and the accompanying materials\r\nare made available under the terms of the Eclipse Public License v1.0\r\nwhich accompanies this distribution, and is available at\r\nhttp://www.eclipse.org/legal/epl-v10.html\r\n\r\nContributors:\r\n    Akos Horvath, Abel Hegedus, Zoltan Ujhelyi, Tamas Borbas - initial API and implementation";

	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static ValuedescriptorFactory init() {
		try {
			ValuedescriptorFactory theValuedescriptorFactory = (ValuedescriptorFactory)EPackage.Registry.INSTANCE.getEFactory(ValuedescriptorPackage.eNS_URI);
			if (theValuedescriptorFactory != null) {
				return theValuedescriptorFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new ValuedescriptorFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValuedescriptorFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case ValuedescriptorPackage.LITERAL_DESCRIPTOR: return createLiteralDescriptor();
			case ValuedescriptorPackage.OPERATION_CALL_DESCRIPTOR: return createOperationCallDescriptor();
			case ValuedescriptorPackage.SINGLE_VARIABLE_DESCRIPTOR: return createSingleVariableDescriptor();
			case ValuedescriptorPackage.COLLECTION_VARIABLE_DESCRIPTOR: return createCollectionVariableDescriptor();
			case ValuedescriptorPackage.PROPERTY_READ_DESCRIPTOR: return createPropertyReadDescriptor();
			case ValuedescriptorPackage.PROPERTY_WRITE_DESCRIPTOR: return createPropertyWriteDescriptor();
			case ValuedescriptorPackage.PARAMETER_DESCRIPTOR: return createParameterDescriptor();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LiteralDescriptor createLiteralDescriptor() {
		LiteralDescriptorImpl literalDescriptor = new LiteralDescriptorImpl();
		return literalDescriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public OperationCallDescriptor createOperationCallDescriptor() {
		OperationCallDescriptorImpl operationCallDescriptor = new OperationCallDescriptorImpl();
		return operationCallDescriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public SingleVariableDescriptor createSingleVariableDescriptor() {
		SingleVariableDescriptorImpl singleVariableDescriptor = new SingleVariableDescriptorImpl();
		return singleVariableDescriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CollectionVariableDescriptor createCollectionVariableDescriptor() {
		CollectionVariableDescriptorImpl collectionVariableDescriptor = new CollectionVariableDescriptorImpl();
		return collectionVariableDescriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyReadDescriptor createPropertyReadDescriptor() {
		PropertyReadDescriptorImpl propertyReadDescriptor = new PropertyReadDescriptorImpl();
		return propertyReadDescriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertyWriteDescriptor createPropertyWriteDescriptor() {
		PropertyWriteDescriptorImpl propertyWriteDescriptor = new PropertyWriteDescriptorImpl();
		return propertyWriteDescriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ParameterDescriptor createParameterDescriptor() {
		ParameterDescriptorImpl parameterDescriptor = new ParameterDescriptorImpl();
		return parameterDescriptor;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ValuedescriptorPackage getValuedescriptorPackage() {
		return (ValuedescriptorPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static ValuedescriptorPackage getPackage() {
		return ValuedescriptorPackage.eINSTANCE;
	}

} //ValuedescriptorFactoryImpl
